<id>
Link to This Topic for YaBB 2.7.00
</id>

<version>
1.8
</version>

<mod info>
Description
-----------
This mod adds a 'Link to This Topic' box below threads in Message View.

Installation
------------
1) Modify YaBB files using YaBMod.
2) Go to 'Admin Center - Forum Settings - Show / Hide Items' to enable this feature.


History
-------
1.0 - First Release - 1st September 2009
1.1 - Fixed issue with unwanted '&' symbols appearing with some peoples servers (Thanks to Carsten for pointing out the fix!) - 7th January 2010
1.1a - Fixed YaBB tag displaying in Template Configuration - 8th January 2010
1.2 - Updated for YaBB 2.5 - 13th January 2011
1.3 - Updated for YaBB 2.6 - 25th Juni 2014 by Pyragony 
1.4 - Updated for YaBB 2.6.1 by Dandello, 4th Sept, 2014
1.5 - Updated for YaBB 2.6.11 by Dandello, Dec 31, 2014
1.6 - Updated for YaBB 2.6.12 by Pyragony, 17th Februar 2016
1.7 - Updated for YaBB 2.7.00 by Dandello, 23th February 2016 
1.7 - Updated for YaBB 2.7.00 strict by Dandello, 14th January 2017 
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://www.boardmod.org
</homepage>

<edit file>
Admin/ManageTemplates.pm
</edit file>

<search for>
if (@managetemplatespmmods) {
</search for>

<add before>
push @managetemplatespmmods, 'Link to This Topic';
</add before>

<search for>
## End Display Template Mod Hook ##
</search for>

<add before>
    $display_template =~
      s/\Q{yabb linktopic}\E//gxsm;    ### Link to This Topic Mod ###
</add before>

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    my $link_topic_mod = q~Link to This Topic|Derek Barnstorm|This mod adds a 'Link to This Topic' box below threads in Message View.|1.8|Jan 14, 2017~;
    push @installed_mods, $link_topic_mod;

</add before>

<edit file>
Admin/NewSettings.pm
</edit file>

<search for>
if (@newsettingspmmods) {
</search for>

<add before>
push @newsettingspmmods, 'Link to This Topic';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ($show_link_topic);
</add before>

<search for>
1;
EOF
</search for>

<add before>
\$show_link_topic = $show_link_topic;       # Set to 1 to display 'Link to This Topic' below threads in message view
</add before>

<edit file>
Admin/Settings_Main.pm
</edit file>

<search for>
if (@settings_mainpmmods) {
</search for>

<add before>
push @settings_mainpmmods, 'Link to This Topic';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ($show_link_topic, %link_topic_txt);
</add before>

<search for>
## Mod values ##
</search for>

<add before>
$show_link_topic ||= q{};
</add before>

<search for>
load_language('Register');
</search for>

<add after>
load_language('Mods/LinkTopic'); ### Link to This Topic Mod ###
</add after>

<search for>
            {
                description =>
                  qq~<label for="showallgroups">$amv_txt{'12'}</label>~,
</search for>

<add before>
    ### Link to This Topic Mod Start ###
            {
               description => qq~<label for="show_link_topic">$link_topic_txt{'10'}</label>~,
               input_html => qq~<input type="checkbox" name="show_link_topic" id="show_link_topic" value="1"${ischecked($show_link_topic)} />~,
               name => 'show_link_topic',
               validate => 'boolean',
            },
    ### Link to This Topic Mod End ###
</add before>

<edit file>
Sources/Display.pm
</edit file>

<search for>
if (@displaypmmods) {
</search for>

<add before>
push @displaypmmods, 'Link to This Topic';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ($show_link_topic);
</add before>

<search for>
    # Mark as read button has no use in global announcements or for guests
</search for>

<add before>
    ### Link to This Topic Mod Start ###
    my $link_topic    = q{};
    my $link_to_perma = q{};
    if ( !$movedflag && !${ $uid . $currentboard }{'rbin'} && $show_link_topic )
    {
        our ( $mylink_to_perma, $mylink_topic, %link_topic_txt );
        load_language('Mods/LinkTopic');
        if ( $accept_permalink || $accept_permafull ) {
            $link_to_perma = $mylink_to_perma;
            my $my_permdomain =
              qq~$perm_domain/$symlink/$permdate/$currentboard/$mnum~;
            $link_to_perma =~ s/{yabb permdomain}/$my_permdomain/gsm;
        }
        $link_topic = $mylink_topic;
        $link_topic =~ s/\Q{yabb link_to_perma}\E/$link_to_perma/xsm;
        $link_topic =~ s/\Q{yabb link_topic_txt01}\E/$link_topic_txt{'01'}/gxsm;
        $link_topic =~ s/\Q{yabb link_topic_txt02}\E/$link_topic_txt{'02'}/gxsm;
        $link_topic =~ s/\Q{yabb link_topic_txt03}\E/$link_topic_txt{'03'}/gxsm;
        $link_topic =~ s/\Q{yabb link_topic_txt04}\E/$link_topic_txt{'04'}/gxsm;
        $link_topic =~ s/\Q{yabb link_topic_txt05}\E/$link_topic_txt{'05'}/gxsm;
        $link_topic =~ s/\Q{yabb link_topic_txt06}\E/$link_topic_txt{'06'}/gxsm;
        $link_topic =~ s/\Q{yabb link_topic_txt07}\E/$link_topic_txt{'07'}/gxsm;
        $link_topic =~ s/\Q{yabb link_topic_txt08}\E/$link_topic_txt{'08'}/gxsm;
        $link_topic =~ s/\Q{yabb link_topic_txt09}\E/$link_topic_txt{'09'}/gxsm;
        $link_topic =~ s/\Q{yabb mnum}/$mnum/gxsm;
        $link_topic =~ s/\Q{yabb msubthread}/$msubthread/gxsm;
    }
    ### Link to This Topic Mod End ###

</add before>

<search for>
## Mod Hook Display_temp ##
</search for>

<add before>
    $display_template =~
      s/\Q{yabb linktopic}\E/$link_topic/gxsm;    ### Link to This Topic Mod ###
</add before>

<edit file>
Templates/default/Display.template
</edit file>

<search for>
if (@defaultdisplaymods) {
</search for>

<add before>
push @defaultdisplaymods, 'Link to This Topic';
</add before>

<search for>
<!-- Threads Admin Button Bar start -->
</search for>

<add before>
<!-- Link to this Topic start -->

{yabb linktopic}

<!-- Link to this Topic end -->

</add before>

<search for>
1;
</search for>

<add before>
### Link to This Topic Mod ###
$mylink_to_perma = qq~<tr>
        <td class="windowbg2"><label for="link_perma"><span class="small" style="font-weight: bold; cursor: pointer;">{yabb link_topic_txt05}:</span></label></td>
        <td class="windowbg2"><input type="text" id="link_perma" class="small" style="width: 98%; cursor: pointer;" onclick="this.select();" value="{yabb permdomain}" title="{yabb link_topic_txt09}" readonly="readonly" /></td>
      </tr>~;

$mylink_topic = qq~
<div class="displaycontainer">
<table class="tabtitle pad_4px">
    <tr>
        <th colspan="2" style="padding-left:1px"><img src="$modimgurl/linktopic.gif" alt="" /> {yabb link_topic_txt01}</th>
    </tr>
</table>
<table class="pad_4px">
    <tr>
        <td class="windowbg2"><label for="link_html"><span class="small" style="font-weight: bold; cursor: pointer; white-space: nowrap;">{yabb link_topic_txt02}:</span></label></td>
        <td class="windowbg2"><input type="text" id="link_html" class="small" style="width: 98%; cursor: pointer;" onclick="this.select();" value="&lt;a href=&quot;$scripturl?num={yabb mnum}&quot; target=&quot;_blank&quot;&gt;{yabb msubthread}&lt;/a&gt;" title="{yabb link_topic_txt06}" readonly="readonly" /></td>
    </tr><tr>
        <td class="windowbg2"><label for="link_bbcode"><span class="small" style="font-weight: bold; cursor: pointer;">{yabb link_topic_txt03}:</span></label></td>
        <td class="windowbg2"><input type="text" id="link_bbcode" class="small" style="width: 98%; cursor: pointer;" onclick="this.select();" value="&#91;url=$scripturl?num={yabb mnum}&#93;{yabb msubthread}&#91;/url&#93;" title="{yabb link_topic_txt07}" readonly="readonly" /></td>
    </tr><tr>
        <td class="windowbg2"><label for="link_url"><span class="small" style="font-weight: bold; cursor: pointer;">{yabb link_topic_txt04}:</span></label></td>
        <td class="windowbg2"><input type="text" id="link_url" class="small" style="width: 98%; cursor: pointer;" onclick="this.select();" value="$scripturl?num={yabb mnum}" title="{yabb link_topic_txt08}" readonly="readonly" /></td>
    </tr>
{yabb link_to_perma}
</table>
</div>
~;

</add before>
